package com.bleujin.framework.db;

import com.bleujin.framework.db.manager.DBManager;
import com.bleujin.framework.db.servant.AfterTask;
import com.bleujin.framework.db.servant.ExtraServant;
import com.bleujin.framework.db.servant.NoneServant;
import com.bleujin.framework.db.servant.ServantChannel;

public class DBSimpleConstroller extends DBController{

	public DBSimpleConstroller(String name, DBManager dbm) throws DBControllerInstantiationException {
		super(name, dbm, new NoneServant());
	}



	static class NoneChannel extends ServantChannel {

		public NoneChannel(ExtraServant servant) {
			super(servant);
		}

		public void startWorker() {
	        log.info(getClass().getName() + " : " + getExtraServant());
	    }		
	    public synchronized void putTask(AfterTask atask) throws InterruptedException {
	    	// ignore
	    }

	    public synchronized AfterTask takeTask() throws InterruptedException {
	    	throw new IllegalStateException("NoneChannel empty") ;
	    }

	    public synchronized void stopServant() {
	    }

	}
}



