package com.bleujin.framework.db;

import com.bleujin.framework.db.procedure.CombinedUserProcedures;
import com.bleujin.framework.db.procedure.IParameterQueryable;
import com.bleujin.framework.db.procedure.IUserCommand;
import com.bleujin.framework.db.procedure.IUserCommandBatch;
import com.bleujin.framework.db.procedure.IUserProcedure;
import com.bleujin.framework.db.procedure.IUserProcedureBatch;
import com.bleujin.framework.db.procedure.UserProcedures;

public interface IQueryFactory {

	public IUserProcedure createUserProcedure(String proc) ;
	public IUserCommand createUserCommand(String proc);
	public IParameterQueryable createParameterQuery(String proc) ;
	public IUserCommandBatch createUserCommandBatch(String procSQL) ;
	public IUserProcedureBatch createUserProcedureBatch(String procSQL) ;

	public UserProcedures createUserProcedures(String name);
	public CombinedUserProcedures createCombinedUserProcedures(String name) ;
	

}
