package com.bleujin.framework.db;

import java.util.HashMap;
import java.util.logging.Logger;

import org.apache.commons.lang.StringUtils;

import com.bleujin.framework.configuration.Configuration;
import com.bleujin.framework.logging.LogBroker;
import com.bleujin.framework.util.CaseInsensitiveHashMap;

public class MidgardProperty {
	
	public static final MidgardProperty EMPTY = new MidgardProperty();

	private HashMap<String, String> properties = new CaseInsensitiveHashMap<String, String>() ;    // etc property...
	private Logger log = LogBroker.getLogger(MidgardProperty.class) ;
	
	private MidgardProperty(){
	}
	
	public MidgardProperty(Configuration[] configs) {
        for (Configuration config : configs) {
        	properties.put(config.getAttribute("key"), config.getAttribute("value")) ;
        }
	}
	
    public String getMidgardProperty(String key){
        return properties.get(key) ;
    }

    public int getMidgardPropertyAsInt(String key, int defaultValue){
        String str = properties.get(key) ;
        return StringUtils.isNumeric(str) ? Integer.parseInt(str) : defaultValue ;
    }
    
    public void setMidgardProperty(String key, String value){
        log.info("Midgard Property[" + key + " : " + value + "] Added");
        properties.put(key, value) ;
    }    
}
