package com.bleujin.framework.db.h2;

import java.sql.Connection;
import java.sql.SQLException;
import java.sql.Statement;

import com.bleujin.framework.db.IDBController;
import com.bleujin.framework.db.procedure.UserCommand;

public class H2UserCommand extends UserCommand {

	protected H2UserCommand(IDBController dc, String sql) {
		super(dc, sql);
	}

	protected int myUpdate(Connection conn) throws SQLException {
		int updateCount;
		try {
			pstmt = conn.prepareStatement(getProcSQL());

			for (int i = 0, last = getParams().size(); i < last; i++) {
				setParam(pstmt, i, getParams().get(i));
			}
			updateCount = pstmt.executeUpdate();
			pstmt.close();
			pstmt = null;
		} finally {
			closeSilence(pstmt) ;
		}
		return updateCount;
	}

	protected Statement getStatement() {
		return pstmt;
	}



}
