package com.bleujin.framework.db.hsql;

import java.sql.Connection;
import java.sql.SQLException;

import com.bleujin.framework.db.manager.PoolHelper;
import com.bleujin.framework.db.procedure.HSQLBean;

public class HSQLPoolDBManager extends HSQLDBManager {
	private int maxLimit = 40;
	private PoolHelper pHelper;

	public HSQLPoolDBManager(HSQLBean bean) {
		super(bean);
	}

	public HSQLPoolDBManager(String configFilePath) {
		super(configFilePath);
	}

	public HSQLPoolDBManager(String configFilePath, int maxLimit) {
		this(configFilePath);
		this.maxLimit = maxLimit;
	}

	protected void myInitPool() throws SQLException {
		try {
			Class.forName(getDriverName());
		} catch (ClassNotFoundException ex) {
			throw new SQLException("Driver Class Not Found", ex.toString());
		}
		pHelper = new PoolHelper(getJdbcURL(), getUserId(), getUserPwd(), maxLimit);
	}

	public Connection getConnection() throws SQLException {
		assert pHelper != null : "dbManager not initialized ";
		return pHelper.getConnection();
	}

	public void freeConnection(Connection conn) throws SQLException {
		pHelper.freeConnection(conn);
	}

	protected void myDestroyPool() throws SQLException{
		pHelper.destroyPoolConnection();
	}

}
