package com.bleujin.framework.db.manager;


public class Connect {
	private java.sql.Connection con = null;
	private final String url = "jdbc:microsoft:sqlserver://";
	private final String serverName = "novision";
	private final String portNumber = "1433";
	private final String databaseName = "pubs";
	private final String userName = "bleu";
	private final String password = "bleu";
	// Informs the driver to use server a side-cursor,
	// which permits more than one active statement
	// on a connection.
	private final String selectMethod = "cursor";

	// Constructor
	public Connect() {
	}

	private String getConnectionUrl() {
		return url + serverName + ":" + portNumber + ";databaseName=" + databaseName + ";selectMethod=" + selectMethod + ";";
	}

	private java.sql.Connection getConnection() {
		try {
			Class.forName("com.microsoft.jdbc.sqlserver.SQLServerDriver");
			con = java.sql.DriverManager.getConnection(getConnectionUrl(), userName, password);
			if (con != null)
				System.out.println("Connection Successful!");
		} catch (Exception e) {
			e.printStackTrace();
			System.out.println("Error Trace in getConnection() : " + e.getMessage());
		}
		return con;
	}

	/*
	 * Display the driver properties, database details
	 */

	public void displayDbProperties() {
		java.sql.DatabaseMetaData dm = null;
		java.sql.ResultSet rs = null;
		try {
			con = this.getConnection();
			if (con != null) {
				dm = con.getMetaData();
				System.out.println("Driver Information");
				System.out.println("tDriver Name: " + dm.getDriverName());
				System.out.println("tDriver Version: " + dm.getDriverVersion());
				System.out.println("nDatabase Information ");
				System.out.println("tDatabase Name: " + dm.getDatabaseProductName());
				System.out.println("tDatabase Version: " + dm.getDatabaseProductVersion());
				System.out.println("Avalilable Catalogs ");
				rs = dm.getCatalogs();
				while (rs.next()) {
					System.out.println("tcatalog: " + rs.getString(1));
				}
				rs.close();
				rs = null;
				closeConnection();
			} else
				System.out.println("Error: No active Connection");
		} catch (Exception e) {
			e.printStackTrace();
		}
		dm = null;
	}

	private void closeConnection() {
		try {
			if (con != null)
				con.close();
			con = null;
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public static void main(String[] args) throws Exception {
		Connect myDbTest = new Connect();
		myDbTest.displayDbProperties();
	}
}

/*
 *  ڵ尡  Ǹ  ϰ µ˴ϴ.
 * 
 * Connection Successful! Driver Information Driver Name: SQLServer Driver
 * Version: 2.2.0022
 * 
 * Database Information Database Name: Microsoft SQL Server Database Version:
 * Microsoft SQL Server 2000 - 8.00.384 (Intel X86) May 23 2001 00:02:52
 * Copyright (c) 1988-2000 Microsoft Corporation Desktop Engine on Windows NT
 * 5.1 (Build 2600: )
 * 
 * Avalilable Catalogs catalog: master catalog: msdb catalog: pubs catalog:
 * tempdb
 */
