package com.bleujin.framework.db.manager;

import java.sql.Connection;
import java.sql.SQLException;

import oracle.jdbc.pool.OracleConnectionCacheImpl;

/**
 * <p>Title: Oracle Connection Cache ϴ DBManager</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: I-ON Communications</p>
 * @author bleujin
 * @version 1.0
 */
public class OracleCacheDBManager extends OracleDBManager
{
    private OracleConnectionCacheImpl ocpds = null;
    private int initConnectionCount = 10 ;

    // Only For Test
    protected OracleCacheDBManager() {
        this("jdbc:oracle:thin:@novision:1521:cassora", "odin", "odin" ,20) ;
    }

    public OracleCacheDBManager( String jdbcURL, String user, String passwd ) {
        this(jdbcURL, user, passwd, 20) ;
    }

    public OracleCacheDBManager( String jdbcURL, String user, String passwd, int connectionLimit ) {
        super(jdbcURL, user, passwd);
        this.initConnectionCount = connectionLimit > 1 ? connectionLimit : 10;
    }

    protected void myInitPool() throws SQLException {
        ocpds = new OracleConnectionCacheImpl();
        ocpds.setURL( getJdbcURL() );
        ocpds.setUser( getUserId() );
        ocpds.setPassword( getUserPwd() );
        ocpds.setMaxLimit( this.initConnectionCount );
        // to resolve a rowset bug; http://developer.java.sun.com/developer/bugParade/bugs/4625851.html
        // NumberFormatException
        System.setProperty( "oracledatabasemetadata.get_lob_precision", "false" ) ;

    }

    public Connection getConnection() throws SQLException {
        return ocpds.getConnection();
    }
    
    public void freeConnection(Connection conn) throws SQLException {
        if (conn != null) {
            conn.setAutoCommit(true); // default.. auto commit
            conn.close();
            // System.out.println( "-- freeConnnection() --" );
        }
    }
    protected void myDestroyPool() throws SQLException {
        if ( ocpds != null ) ocpds.close();
        ocpds = null;
    }

    public int getDBManagerType() {
        return DBType.OracleCacheDBManager;
    }
}
