package com.bleujin.framework.db.mysql;

import java.sql.CallableStatement;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.sql.Types;

import com.bleujin.framework.db.IDBController;
import com.bleujin.framework.db.Rows;
import com.bleujin.framework.db.procedure.UserProcedure;

public class MySQLUserProcedure extends UserProcedure{


    private CallableStatement cstmt ;

    public MySQLUserProcedure(IDBController dc, String procSQL) {
        super(dc, procSQL) ;
    }


    protected Statement getStatement(){
        return cstmt ;
    }

    @Override
    protected Rows myQuery(Connection conn) throws SQLException{
        Rows result = null ;
        ResultSet rs = null ;

        try {
            cstmt = conn.prepareCall( "{ call " + getProcedureSQL() + "}", ResultSet.TYPE_SCROLL_INSENSITIVE,  ResultSet.CONCUR_READ_ONLY );
            cstmt.setMaxRows(getMaxRows()) ;
            cstmt.setFetchSize(getFetchSize());
            
            for ( int i = 0; i < getParams().size(); i++ ) {
                setParam(i, getParams().get(i) );
            }
            rs = cstmt.executeQuery() ;
            result = super.populate(rs);
        } catch ( SQLException ex ) {
            throw new SQLException( getExceptionMessage(ex, this), ex.getSQLState(), ex.getErrorCode() );
        } finally {
        	closeSilence(rs, cstmt, conn) ;
        }

        return result;
    }

    protected String getProcedureSQL() {
        String procSQL = getProcSQL().replace( '@', '_' );
        return procSQL ;
    }



    protected int myUpdate(Connection conn) throws SQLException {
        int updateRow = 0 ;
        try {
            cstmt = conn.prepareCall( "{? = call " + getProcedureSQL() + "}" );

            for ( int i = 0; i < getParams().size(); i++ ) {
                int mediateLoc =  i + 1 ; // return + start zero...
                Object obj = getParams().get(i) ;

                if(isNull(i)) {
                    cstmt.setNull(mediateLoc+1, getType(i));
                } else {
                    cstmt.setObject(mediateLoc+1, obj);
                }
            }
            cstmt.registerOutParameter( 1, Types.INTEGER);
            updateRow = cstmt.executeUpdate();
            updateRow = cstmt.getInt(1) ;
        } catch ( SQLException ex ) {
            throw new SQLException( getExceptionMessage(ex, this), ex.getSQLState(), ex.getErrorCode() );
        } finally {
            if ( cstmt != null ) cstmt.close();
            cstmt = null ;
        }
        return updateRow;
    }

    protected void setParam(int i, Object obj ) throws SQLException {
        int mediateLoc =  i + 1 ; // return + start zero...

        if(isNull(i)) {
            cstmt.setNull(mediateLoc, getType(i));
        } else {
            cstmt.setObject(mediateLoc, obj);
        }
    }
}
