package com.bleujin.framework.db.procedure;

import java.util.HashMap;

import junit.framework.Assert;

public class HSQLBean {
    private String address = "127.0.0.1";
    private String name = "";
    private String userId = "sa";
    private String userPwd = "";

    private HashMap procedures = new HashMap() ;

    public HSQLBean() {
    }

    public String getAddress() {
        return address;
    }

    public void setAddress(String address) {
        this.address = address;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getUserId() {
        return userId;
    }

    public void setUserId(String userId) {
        this.userId = userId;
    }

    public String getUserPwd() {
        return userPwd;
    }

    public void setUserPwd(String userPwd) {
        this.userPwd = userPwd;
    }

    public void addProcedure(ProcedureBean proc){
        Assert.assertNotNull("hsql procedure id is not null", proc.getId());
        procedures.put(proc.getId().toUpperCase(), proc) ;
    }

    public ProcedureBean[] getProcedures(){
        return (ProcedureBean[])procedures.values().toArray(new ProcedureBean[0]) ;
    }

    public ProcedureBean getProcedure(String id){
        Assert.assertNotNull("hsql procedure id is not null", id);
        return (ProcedureBean)procedures.get(id.toUpperCase()) ;
    }
}

