package com.bleujin.framework.db.procedure;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.sql.CallableStatement;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.sql.Types;

import com.bleujin.framework.db.IDBController;
import com.bleujin.framework.db.Rows;



/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author bleujin
 * @version 1.0
 */

public class MSSQLUserProcedure extends UserProcedure {

    private PreparedStatement pstmt = null;

    MSSQLUserProcedure(IDBController dc, String procSQL) {
        super(dc, procSQL);
    }

    protected Statement getStatement(){
        return pstmt ;
    }

    @Override
    protected Rows myQuery(Connection conn) throws SQLException {

        Rows result = null;
        ResultSet rs = null ;
        String procSQL = (getProcSQL().replace('(', ' ')).replace(')', ' ');

        try {
            pstmt = conn.prepareStatement("Exec " + procSQL);
            pstmt.setMaxRows(getMaxRows());
            pstmt.setFetchSize(getFetchSize());

            for (int i = 0; i < getParams().size(); i++) {
                setParam(pstmt, i, 1);
            }
            rs = pstmt.executeQuery() ;
            result = super.populate(rs);
        } catch (IOException ex) {
            throw new SQLException(getExceptionMessage(ex, this));
        } catch (SQLException ex) {
            throw new SQLException(getExceptionMessage(ex, this), ex.getSQLState(), ex.getErrorCode());
        } finally {
        	closeSilence(rs, pstmt, conn) ;
        }
        return result;
    }

    protected int myUpdate(Connection conn) throws SQLException {
        int result = 0;
       try {
           pstmt = (CallableStatement)conn.prepareCall("{? = call " + getProcSQL() + "}");
           CallableStatement cstmt = (CallableStatement)pstmt ;
           cstmt.registerOutParameter(1, Types.INTEGER);

           for (int i = 0; i < getParams().size(); i++) {
               setParam(cstmt, i, 2);
           }

           cstmt.executeUpdate();
           result = cstmt.getInt(1);

           cstmt.close();
       } catch (IOException ex) {
           throw new SQLException(ex.getMessage());
       } catch (SQLException ex) {
           throw ex;
       } finally {
    	   closeSilence(pstmt) ;
       }

       return result;
    }


    private void setParam(PreparedStatement modifyps, int i, int mediateLoc) throws SQLException, IOException, FileNotFoundException {

        if (isBlobType(i)) {
            //prepare FileInputStream
            String fileName = (String) getParams().get(getBlobParamIndex(0));
            File file = new File(fileName);
            int FileLength = (int) file.length();
            FileInputStream fis = new FileInputStream(file);

            modifyps.setBinaryStream(i + mediateLoc, fis, FileLength); //method to insert a stream of bytes
        } else if (isNull(i)) {
            modifyps.setNull(i + mediateLoc, getType(i));
        } else {
            modifyps.setObject(i + mediateLoc, getParams().get(i));
        }
    }
}
