package com.bleujin.framework.db.procedure;

import java.io.FileNotFoundException;
import java.io.InputStream;
import java.sql.Connection;
import java.sql.SQLException;
import java.sql.Statement;

import oracle.jdbc.driver.OracleCallableStatement;

import com.bleujin.framework.db.IDBController;

public class Oracle8iUserProcedureBatch extends OracleUserProcedureBatch {

    Oracle8iUserProcedureBatch(IDBController dc, String procSQL) {
        super(dc, procSQL) ;
    }

    protected Statement getStatement(){
        return cstmt ;
    }

    public void addClob(int paramindex, String clobString){
        throw new IllegalArgumentException("Not Supported Operation. Use it at Oracle 9.2.0.4 higher version with Oracle9iDBManager") ;
    }
    public void addClob(int paramindex, String[] clobString){
        throw new IllegalArgumentException("Not Supported Operation. Use it at Oracle 9.2.0.4 higher version with Oracle9iDBManager") ;
    }
    public void addClob(int paramindex, String clobString, int size){
        throw new IllegalArgumentException("Not Supported Operation. Use it at Oracle 9.2.0.4 higher version with Oracle9iDBManager") ;
    }

    public void addBlob( int paramindex, String fileName) throws FileNotFoundException {
        throw new IllegalArgumentException("Not Supported Operation. Use it at Oracle 9.2.0.4 higher version with Oracle9iDBManager") ;
    }
    public void addBlob(int paramindex, InputStream is) {
        throw new IllegalArgumentException("Not Supported Operation. Use it at Oracle 9.2.0.4 higher version with Oracle9iDBManager") ;
    }
    public void addBlob( int paramindex, String fileName, int size) throws FileNotFoundException {
        throw new IllegalArgumentException("Not Supported Operation. Use it at Oracle 9.2.0.4 higher version with Oracle9iDBManager") ;
    }
    public void addBlob( int paramindex, InputStream is, int size) {
        throw new IllegalArgumentException("Not Supported Operation. Use it at Oracle 9.2.0.4 higher version with Oracle9iDBManager") ;
    }
    public void addBlob( int paramindex, String[] fileName) throws FileNotFoundException {
        throw new IllegalArgumentException("Not Supported Operation. Use it at Oracle 9.2.0.4 higher version with Oracle9iDBManager") ;
    }
    public void addBlob(int paramindex, InputStream[] is) {
        throw new IllegalArgumentException("Not Supported Operation. Use it at Oracle 9.2.0.4 higher version with Oracle9iDBManager") ;
    }

    protected int myUpdate(Connection conn) throws SQLException {
        int[] updateRow;

        try {
            String procSQL = getProcSQL().replace('@', '.');
            cstmt = (OracleCallableStatement) conn.prepareCall("{call " + procSQL + "}");
            Object[][] values = getParamsAsArray(); // [a][b] a : rows, b : column

            for (int row = 0, rlast = values.length > 0 ? values[0].length : 0 ; row < rlast ; row++) {
                for ( int col = 0, clast = values.length ; col < clast ; col++ ) {
                    Object obj = values[col][row] ;
                    setParam(col, obj);
                }
                cstmt.addBatch();
            }

            updateRow = cstmt.executeBatch();
            cstmt.close();
        } catch (SQLException ex) {
            throw ex ;
        } finally {
      	   closeSilence(cstmt) ;
        }

        return updateRow.length;
    }

    protected void setParam(int i, Object obj ) throws SQLException {
        int mediateLoc =  i + 2 ; // return + start zero...

        if(isNull(i)) {
            cstmt.setNull(mediateLoc, getType(i));
            // modifyps.setNull();
        } else {
            cstmt.setObject(mediateLoc, obj);
        }
    }

}
