package com.bleujin.framework.db.procedure;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import oracle.jdbc.OraclePreparedStatement;

import com.bleujin.framework.db.IDBController;
import com.bleujin.framework.db.Rows;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2005</p>
 * <p>Company: i-on</p>
 * @author bleujin
 * @version 1.0
 */

public class OracleImplicitCacheCommand extends OracleUserCommand{

	OracleImplicitCacheCommand(IDBController dc, String strSQL ) {
        this(dc, strSQL, QueryType.USER_COMMAND) ;
    }

    OracleImplicitCacheCommand(IDBController dc, String strSQL, int queryType ) {
        super(dc, strSQL, queryType) ;
    }
    protected Statement getStatement(){
        return pstmt ;
    }

    @Override
    protected Rows myQuery(Connection conn) throws SQLException {
        ResultSet rs = null;
        Rows result = null ;

        try {
//            ((OracleConnection) conn).setStmtCacheSize(40); // Set the Statement cache size to 40
//            ((OracleConnection) conn).setStatementCacheSize(40); // Set the Statement cache size to 40
//            ((OracleConnection) conn).setImplicitCachingEnabled(true); // Set the Statement cache size to 40
            conn.setTransactionIsolation(Connection.TRANSACTION_READ_COMMITTED);

            pstmt = (OraclePreparedStatement)conn.prepareStatement(getProcSQL());
            for (int i = 0; i < getParams().size(); i++) {
                Object obj = getParams().get(i);
                setParam(pstmt, i, obj);
            }

            rs = pstmt.executeQuery();
            rs.setFetchSize(DEFAULT_FETCHSIZE);
            result = super.populate(rs);
        } catch (SQLException ex) {
            throw new SQLException(getExceptionMessage(ex, this), ex.getSQLState(), ex.getErrorCode());
        } finally {
        	closeSilence(rs, pstmt, conn) ;
        }

        return result;
    }

}
