package com.bleujin.framework.db.procedure;

import java.io.IOException;
import java.io.OutputStream;
import java.sql.Connection;
import java.sql.SQLException;
import java.sql.Statement;

import com.bleujin.framework.db.IDBController;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: I-ON Communications</p>
 * @author bleujin
 * @version 1.0
 */

public class OracleUserCommand extends UserCommand {

    OracleUserCommand(IDBController dc, String strSQL ) {
        this(dc, strSQL, QueryType.USER_COMMAND) ;
    }

    OracleUserCommand(IDBController dc, String strSQL, int queryType ) {
        super(dc, strSQL, queryType) ;
    }

    protected Statement getStatement(){
        return pstmt ;
    }

    public void printPlan(OutputStream output) throws SQLException {
    	OracleUserCommandPlan plan = new OracleUserCommandPlan(getDBController(), this) ;
    	plan.printPlan(output) ;
    }
    
    protected int myUpdate(Connection conn) throws SQLException {
        int updateCount;
        try {
            pstmt = conn.prepareStatement(getProcSQL());
            OracleQueryUtils.setParam(conn, pstmt, getParams(), getTypes(), OracleQueryUtils.COMMAND_LOC );
            updateCount = pstmt.executeUpdate();

            pstmt.close();
            pstmt = null ;
        }
        catch (IOException ex) {
            throw new SQLException(ex.getMessage()) ;
        } finally{
			closeSilence(pstmt) ;
        }
        return updateCount ;
    }

}
