package com.bleujin.framework.db.procedure;

import java.io.IOException;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import oracle.jdbc.driver.OracleCallableStatement;
import oracle.jdbc.driver.OracleTypes;

import com.bleujin.framework.db.IDBController;
import com.bleujin.framework.db.Rows;
/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author bleujin
 * @version 1.0
 */

public class OracleUserProcedure extends UserProcedure{

    private OracleCallableStatement cstmt ;

    OracleUserProcedure(IDBController dc, String procSQL) {
        super(dc, procSQL) ;
    }


    protected Statement getStatement(){
        return this.cstmt ;
    }

    @Override
    protected Rows myQuery(Connection conn) throws SQLException{
        Rows result = null ;
        ResultSet rs = null ;

        try {
            cstmt = ( OracleCallableStatement )conn.prepareCall( "{? = call " + getProcedureSQL() + "}", ResultSet.TYPE_SCROLL_INSENSITIVE,  ResultSet.CONCUR_READ_ONLY );
            cstmt.setMaxRows(getMaxRows());
            cstmt.setFetchSize(getFetchSize());
            
            cstmt.setRowPrefetch(getFetchSize());

            cstmt.registerOutParameter(1, OracleTypes.CURSOR) ;
            for ( int i = 0; i < getParams().size(); i++ ) {
                setParam(i, getParams().get(i) );
            }
            cstmt.executeQuery() ;
            rs = (ResultSet) cstmt.getObject(1) ;
            result = super.populate(rs);
        } catch ( SQLException ex ) {
            throw new SQLException( getExceptionMessage(ex, this), ex.getSQLState(), ex.getErrorCode() );
        } finally {
        	closeSilence(rs, cstmt, conn) ;
        }

        return result;
    }

    protected String getProcedureSQL() {
        String procSQL = getProcSQL().replace( '@', '.' );
        return procSQL;
    }



    protected int myUpdate(Connection conn) throws SQLException {
        int updateRow = 0 ;
        try {

            cstmt = ( OracleCallableStatement )conn.prepareCall( "{? = call " + getProcedureSQL() + "}" );
            cstmt.registerOutParameter( 1, OracleTypes.NUMBER );

            OracleQueryUtils.setParam(conn, cstmt, getParams(), getTypes(), OracleQueryUtils.PROCEDURE_LOC );

            cstmt.executeUpdate();
            updateRow = cstmt.getInt( 1 );

        } catch ( IOException ex ) {
            throw new SQLException( ex.getMessage() );
        } catch ( SQLException ex ) {
            throw new SQLException( getExceptionMessage(ex, this), ex.getSQLState(), ex.getErrorCode() );
        } finally {
            if ( cstmt != null ) cstmt.close();
            cstmt = null ;
        }
        return updateRow;
    }


    protected void setParam(int i, Object obj ) throws SQLException {
        int mediateLoc =  i + 2 ; // return + start zero...

        if(isNull(i)) {
            cstmt.setNull(mediateLoc, getType(i));
            // modifyps.setNull();
        } else {
            cstmt.setObject(mediateLoc, obj);
        }
    }

}

