package com.bleujin.framework.db.procedure;

import java.io.OutputStream;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import org.apache.commons.lang.StringUtils;

import com.bleujin.framework.db.IDBController;
import com.bleujin.framework.db.Rows;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author bleujin
 * @version 1.0
 */

public abstract class UserCommand extends ParameterQueryable implements IUserCommand{

    protected PreparedStatement pstmt = null ;

    protected UserCommand(IDBController dc, String strSQL ) {
        this(dc, strSQL, QueryType.USER_COMMAND) ;
    }

    UserCommand(IDBController dc, String strSQL, int queryType ) {
        super(dc, strSQL, queryType) ;
    }

    protected Statement getStatement(){
        return pstmt ;
    }

    protected void setParam(int i, Object obj) throws SQLException {
        setParam(pstmt, i, obj);
    }

    protected void setParam(PreparedStatement pstmt, int i, Object obj) throws SQLException {
        if (isNull(i)) {
            pstmt.setNull(i + 1, getType(i));
        } else {
            pstmt.setObject(i + 1, obj);
        }
    }

    protected Rows myQuery(Connection conn) throws SQLException {
        ResultSet rs = null;
        try {
            pstmt = conn.prepareStatement(getProcSQL(), ResultSet.TYPE_FORWARD_ONLY, ResultSet.CONCUR_READ_ONLY);
            pstmt.setMaxRows(getMaxRows()) ;
            pstmt.setFetchSize(getFetchSize()) ;

            // result.setTransactionIsolation(java.sql.Connection.TRANSACTION_READ_UNCOMMITTED);
            for (int i = 0; i < getParams().size(); i++) {
                setParam(i, getParams().get(i));
            }

            rs = pstmt.executeQuery();
            // rs.setFetchSize(DEFAULT_FETCHSIZE);

            Rows result = populate(rs) ;

            return result;
        } catch (SQLException ex) {
            throw new SQLException(getExceptionMessage(ex, this), ex.getSQLState(), ex.getErrorCode());
        } finally {
        	closeSilence(rs, pstmt, conn) ;
        }

    }


    public void printPlan(OutputStream output) throws SQLException {
    	throw new UnsupportedOperationException() ;
    }

    public String[] getParamsAsString(int index) {
        Object obj = params.get(index) ;
        if (obj == null) return new String[]{""} ;
        else return new String[]{ String.valueOf(obj)} ;
    }

    public String getProcFullSQL(){
        String result = getProcSQL() ;
        for(int i=0, last=params.size() ; i < last ; i++){
            String value = params.get(i) == null ? "null" :  "'" + params.get(i).toString().replaceAll("'", "''") + "'"  ;
            result = StringUtils.replaceOnce(result, "?", value) ;
        }
        return result ;
    }

}
