package com.bleujin.framework.db.querybuilder;

import java.util.Vector;

import org.apache.commons.lang.StringUtils;

public class OracleQueryBuilder extends QueryBuilder
{
    public OracleQueryBuilder() {
        super();
    }

    public OracleQueryBuilder(String aliasName) {
        super(aliasName);
    }

    protected String makeSelect() {
        return "select " + getHint(); // Magic String -_-
        // return "select";
    }

    protected String makeColumn() {
        return super.makeColumn();
    }

    protected String makeWhere() {
        String result = "";
        int i;

        if(relations.size() > 0) {
            for(i = 0; i < relations.size() - 1; i++) {
                result += relations.get(i) + " and ";
            }
            result += relations.get(i);
            return " where " + result + makeFilter() + makeLimit();
        } else {
            if(filters.size() > 0) {
                return " where " + makeFilter() + makeLimit();
            } else if(filters.size() == 0 && limit > 0) {
                return " where " + " 1=1 " + makeLimit(); // 1=1 -> dummy condition
            } else {
                return "";
            }
        }
    }

    protected String makeLimit() {
        if(limit > 0)
            return " and rownum <= " + String.valueOf(limit);
        else
            return "";
    }

    private String makeFilter() {
        String result = relations.size() * filters.size() > 0 ? " and " : "";
        result = result + makeStringFromArray(filters, " and ", "");
        if(result.length() > 0) {
            result = " " + result;
        }

        return result;
    }

    public void setRightOuterRelation(int table1_index, int table2_index, String table1_colName, String table2_colName) {
        String join = this.aliasName + String.valueOf(table1_index) + "." + table1_colName + "(+) = " + this.aliasName + String.valueOf(table2_index) + "." + table1_colName;
        relations.add(join);
    }

    public void setLeftOuterRelation(int table1_index, int table2_index, String table1_colName, String table2_colName) {
        String join = this.aliasName + String.valueOf(table1_index) + "." + table1_colName + " = " + this.aliasName + String.valueOf(table2_index) + "." + table1_colName + "(+)";
        relations.add(join);
    }

    public String _SQLOfKeyword(String QB_0_artId, String val) {
        return QB_0_artId + " in (select artId from (select Utils.getIndexString(arrKeyWord, divString, no1) keywordNm from (" +
            "select '" + val + "' arrKeyWord, ';' divString from dual) t1, copy_tblc ct where ct.no1 <= Utils.getIncludeCount(arrKeyWord, divString)) x1, article_keyword_tblc x2 where x2.keywordNm like x1.keywordNm)";
    }

    public String _SQLOfRelation(String catId, String artId, String retKindCd, String QB_0_catId, String QB_0_artId) {
        return "(" + QB_0_catId + ", " + QB_0_artId + ") in (select lowerCatId, lowerArtId from article_rel_tblc " +
            "where upperCatId = '" + catId + "' and upperArtId = " + artId + " and relKindCd like '" + retKindCd + "%')";
    }

    public String _SQLOFToday(String conditionType, String col, String op, String refDateStr, String oper, String num, String subQueryOfArrCatId) {
        if(conditionType.equalsIgnoreCase("logical")) {
            return "substr(" + col + ",1,8) " + op +
                "(select decode(substr(max(" + col + "),1,8)," + "substr('" + refDateStr + "',1,8)," +
                "to_char(to_date('" + refDateStr + "','YYYYMMDD-HH24MISS') " + oper + " " + num + ", 'YYYYMMDD')," +
                "to_char(to_date('" + refDateStr + "','YYYYMMDD-HH24MISS') " + oper + " " + num +
                " - (to_date('" + refDateStr + "','YYYYMMDD-HH24MISS') - to_date(max(" + col + "),'YYYYMMDD-HH24MISS')), 'YYYYMMDD')) " +
                "from publish_general_vw " +
                "where catId in " + subQueryOfArrCatId + " and substr(" + col + ",1,8) <= substr('" + refDateStr + "',1,8) )";
        } else { // ostime
            return "substr(" + col + ",1,8) " + op +
                "to_char(to_date('" + refDateStr + "', 'YYYYMMDD-HH24MISS') " + oper + " " + num + " , 'YYYYMMDD')";
        }

    }

    public String _SQLOfAFieldGeneralSearchCondition(String qbIndex, String afieldId, String afieldTypeCd, String op, String valExpression) {
        return
            " " + qbIndex + "." + "afieldId(+) = '" + afieldId + "'" +
            " and " + qbIndex + "." + "dValue " + transOperator(op, valExpression, afieldTypeCd);
//            " and nvl(" + qbIndex + "." + "dValue, ' ') " + transOperator(op, valExpression, afieldTypeCd);

//            " and Decode('" + afieldTypeCd + "', " +
//            "                 'String',     " + qbIndex + "." + "ContForChar(+), " +
//            "                 'MultSelect', " + qbIndex + "." + "ContForChar(+), " +
//            "                 'LongString', " + qbIndex + "." + "ContForChar(+), " +
//            "                 'Boolean',    " + qbIndex + "." + "ContForBoolean(+), " +
//            "                 'Image'  ,    " + qbIndex + "." + "ContForImg(+), " +
//            "                 'File'  ,     " + qbIndex + "." + "ContForFile(+), " +
//            "                 'Currency',   to_char(" + qbIndex + "." + "ContForMoney(+)), " +
//            "                 'Date',       to_char(" + qbIndex + "." + "ContForDate(+), 'YYYYMMDD-HH24MISS'), " +
//            "                 'Float',      to_char(" + qbIndex + "." + "ContForFloat(+)), " +
//            "                 'Number',     to_char(" + qbIndex + "." + "ContForInt(+)) ) " + transOperator(op, valExpression, afieldTypeCd);
    }

    public String _SQLOfAFieldSpecialCaseSearchCondition(String qbIndex, String afieldId, String afieldTypeCd, String op, String valExpression) {
        // ϴ ӽ÷   Ф -- by novision...
        if("Date".equals(afieldTypeCd)){
            return
            " " + qbIndex + "." + "afieldId = '" + afieldId + "'" +
            " and " + qbIndex + "." + "dValue link '" + valExpression + "%'" ;
//            " and to_char(" + qbIndex + "." + "ContForDate, 'YYYYMMDD-HH24MISS') like '" + valExpression + "%'" ;
        }

        return
            " " + qbIndex + "." + "afieldId = '" + afieldId + "'" +
            " and " + qbIndex + "." + "hashValue = dbms_utility.get_hash_value('" + valExpression + "', 0, 100000000) " +
            " and " + qbIndex + "." + "dValue  = '" + valExpression + "'";
//            " and Decode('" + afieldTypeCd + "', " +
//            "                 'String',     " + qbIndex + "." + "ContForChar, " +
//            "                 'MultSelect', " + qbIndex + "." + "ContForChar, " +
//            "                 'LongString', " + qbIndex + "." + "ContForChar, " +
//            "                 'Boolean',    " + qbIndex + "." + "ContForBoolean, " +
//            "                 'Image'  ,    " + qbIndex + "." + "ContForImg, " +
//            "                 'File'  ,     " + qbIndex + "." + "ContForFile, " +
//            "                 'Currency',   to_char(" + qbIndex + "." + "ContForMoney), " +
//            "                 'Date',       to_char(" + qbIndex + "." + "ContForDate, 'YYYYMMDD-HH24MISS'), " +
//            "                 'Float',      to_char(" + qbIndex + "." + "ContForFloat), " +
//            "                 'Number',     to_char(" + qbIndex + "." + "ContForInt) ) = '" + valExpression + "'";
    }

    public String _SQLOfAFieldAdvancedSearchCondition(String QB_0_artId, String afieldId, String afieldTypeCd, String op, String valExpression) {
        return "Afield.isCompare(" + QB_0_artId + ", '" + afieldId + "', '" + afieldTypeCd + "', '" + transOp(op) + "', '" + valExpression + "') = 1 ";
    }

    public String _SQLOfAFieldConvertedValue(String QB_0_artId, String col) {
        return "Afield.getConvertedValue(" + QB_0_artId + ", '" + col.toLowerCase() + "')";
    }

    public String _SQLOFAfieldVersioning(String QB_0_modSerNo, String QB_1_modSerNo) {
        return
            " and " + QB_0_modSerNo + " = " + QB_1_modSerNo;
    }

    public String _SQLOfMetaSearchCondition(String t1_catId, String col, String op, String val) {
        return " Site_Category.isCompare(" + t1_catId + ", '" + col + "', '" + transOp(op) + "', '" + val + "') = 1 ";
    }

    public String _SQLOfMetaConvertedValue(String t1_catId, String col) {
        return "Site_Category.getConvertedValue(" + t1_catId + ", '" + col + "')";
    }

    public String _SQLOfLimit(String sql, int limit) {
        return limit == 0 ? sql : "Select * From (" + sql + ") ltable Where rownum <= " + limit;
    }

    public String _SQLOfCatFilter(String[] catId, boolean isBelow, Vector afieldIds) {
        String arrCatId = StringUtils.join(catId);

        if(afieldIds.size() == 0) {
            return "(" +
                " Select Utils.getIndexString('" + arrCatId + "', ',', no1) catId From copy_tblc Where no1 <= Utils.getIncludeCount('" + arrCatId + "', ',') " +
                " Union All " +
                " select catId From category_tblc c1 " +
                " connect by prior catId = upperCatId and isRemoved = 'F' start with catId in (" + convertArrayToStartWithString(catId) + ") and 'T'=" + (isBelow ? "'T'" : "'F'") + ")";
        } else {
            return "(" +
                " Select Utils.getIndexString('" + arrCatId + "', ',', no1) catId From copy_tblc Where no1 <= Utils.getIncludeCount('" + arrCatId + "', ',') " +
                " Union All " +
                " select catId From category_tblc c1 " +
                " Where Exists ( Select 1 From category_afield_tblc Where catId = c1.catId and afieldId in (" + convertArrayToStartWithString((String[])afieldIds.toArray(new String[0])) + ") )" +
                " connect by prior catId = upperCatId and isRemoved = 'F' start with catId in (" + convertArrayToStartWithString(catId) + ") and 'T'=" + (isBelow ? "'T'" : "'F'") + ")";
        }

    }

}
