package com.bleujin.framework.db.sample;

import junit.framework.Test;
import junit.framework.TestSuite;
import junit.textui.TestRunner;

import com.bleujin.framework.db.sample.dc.ConnectionLess;
import com.bleujin.framework.db.sample.dc.DCInit;
import com.bleujin.framework.db.sample.extend.CombinedQuery;
import com.bleujin.framework.db.sample.extend.LobHandle;
import com.bleujin.framework.db.sample.extend.NamedParameter;
import com.bleujin.framework.db.sample.extend.QueryPage;
import com.bleujin.framework.db.sample.first.P1_SelectQuery;
import com.bleujin.framework.db.sample.first.P2_UpdateQuery;
import com.bleujin.framework.db.sample.first.P3_BatchCommandQuery;
import com.bleujin.framework.db.sample.first.P4_UserProcedure;
import com.bleujin.framework.db.sample.first.P5_UserProceduresQuery;
import com.bleujin.framework.db.sample.first.P6_UserProceduresUpdate;
import com.bleujin.framework.db.sample.handler.UseHandler;
import com.bleujin.framework.db.sample.plan.ViewPlan;
import com.bleujin.framework.db.sample.rows.RowsFirstRow;
import com.bleujin.framework.db.sample.rows.RowsGet;
import com.bleujin.framework.db.sample.rows.RowsPage;
import com.bleujin.framework.util.Debug;

public class DBSampleAllTest {
	public static Test suite() {
		System.setProperty(Debug.PROPERTY_KEY, "off") ;
		
		TestSuite suite = new TestSuite(DBSampleAllTest.class.getPackage().getName());

		// dc
		suite.addTestSuite(DCInit.class) ;
		suite.addTestSuite(ConnectionLess.class) ;
		
		// first
		suite.addTestSuite(P1_SelectQuery.class) ;
		suite.addTestSuite(P2_UpdateQuery.class) ;
		suite.addTestSuite(P3_BatchCommandQuery.class) ;
		suite.addTestSuite(P4_UserProcedure.class) ;
		suite.addTestSuite(P5_UserProceduresQuery.class) ;
		suite.addTestSuite(P6_UserProceduresUpdate.class) ;
		
		// extend
		suite.addTestSuite(CombinedQuery.class) ;
		// suite.addTestSuite(DTransaction.class) ;  // MSSQL Xa Configuration DTC  Ǿ ־ Ѵ.  
		suite.addTestSuite(LobHandle.class) ;
		suite.addTestSuite(NamedParameter.class) ;
		suite.addTestSuite(QueryPage.class) ;

		// handler
		suite.addTestSuite(UseHandler.class) ;
		
		// plan
		suite.addTestSuite(ViewPlan.class) ;
		
		// rows
		suite.addTestSuite(RowsFirstRow.class) ;
		suite.addTestSuite(RowsGet.class) ;
		suite.addTestSuite(RowsPage.class) ;
		


		return suite;
	}
	
	public static void main(String[] args) {
		TestRunner.run(DBSampleAllTest.suite()) ;
	}
}
