package com.bleujin.framework.db.sample.rows;

import java.sql.Date;

import com.bleujin.framework.db.Rows;
import com.bleujin.framework.db.procedure.IUserProcedure;
import com.bleujin.framework.db.sample.SampleTestBase;

public class RowsGet extends SampleTestBase{


	
	public void testDate() throws Exception {
		String query = "select now() day" ;
		// select a, b, sysdate day from update_sample where a = v_a ;
		Rows rows = dc.createUserProcedure("Sample@selectEmpBy()").execQuery() ;
		
		rows.next() ;
		Date d = rows.getDate("hiredate") ;
		

		assertEquals(17, d.getDate()) ; // smith
	}

	
	/*
	 * Rows ⺻ ResultSet impl ü̱  ResultSet ޼ҵ忡  ġȯĢ - LSP   
	 *  ϳ ǵ ٸ. 
	 * 
	 * ٷ Clob(or Text) ＼ ϴ ε. 
	 * Clob  Ⱑ  ؽƮ ִٸ  Ʈ  ϴ° ´. 
	 * ׷  99.9% ؾ K  ؽƮ ̰ ̴ varchar Ѱ趧 ¿   ̱⵵ ϴ.
	 * ( DB  Ȥ   ݾ ̰ ִ. )
	 * 
	 *  
	 * ׷ Rows  ϱ⿡  ٸ ⺻ RowsImpl ü
	 * Get޼ҵ 
	 * ⺻  RowsImpl Get Ҷ Clob Varchar  ʴ´. 
	 *  Clob ÷ getҶ Ȱ getString()  ü ִ. 
	 * 
	 * Set 
	 * Ϲ Get ޸ Clob or Text insert ϴ° DB  ٸ  ϳ ̽ ϴ  ƴ.
	 *  
	 * ܼ Message ü IQueryable ü ڷ ޴ Param Clob óؾ ϴ String(Varchar) óؾ ϴ° 
	 * Ǵϴ  Ʊ   addClobó  Ķ͸ ؾ ϴ Oracle DB ְ
	 *   DB ִ.  ̰ IQueryable ϴ ü å ְ ڴ ̿  ذå ־ Ѵ.
	 *  Clob(Or Text) insert or updateҶ addClob param ϵ ؾ Ѵ.  
	*/
	
	public void testSetClob() throws Exception {
		StringBuilder textString = new StringBuilder() ;
		for (int i = 0; i < 200; i++) {
			textString.append("01234567890123456789012345678901234567890123456789") ; // 10k
		}
		// insert into lob_sample(a, c) values(v_a, v_b) ;
		IUserProcedure upt = dc.createUserProcedure("Sample@insertLobWith(?,?)") ;
		upt.addParam(1).addClob(textString.toString()) ;
		
		assertEquals(1, upt.execUpdate()) ;
	}
	
	
	public void testGetClob() throws Exception {
		testSetClob() ;

		IUserProcedure upt = dc.createUserProcedure("Sample@selectLobBy(:a)") ;
		upt.addParam("a", 1);
		
		Rows rows = upt.execQuery();
		assertEquals(true, rows.firstRow().getString("c").length() > 9000) ;

		dc.execUpdate("delete from lob_sample") ;
	}
}
