package com.bleujin.framework.db.servant;

import com.bleujin.framework.db.procedure.IQueryable;
import com.bleujin.framework.db.procedure.QueryType;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: I-ON Communications</p>
 * @author bleujin
 * @version 1.0
 */

public class StdOutServant extends ExtraServant {
    private int showLevel;
    public final static int ONLY_USERPROCEDURE = 1;
    public final static int ONLY_USERCOMMAND = 2;
    public final static int ONLY_USERPROCEDUREBATCH = 4;
    public final static int ONLY_USERPROCEDURES = 8;
    public final static int ONLY_USERCOMMANDBATCH = 16;
    public final static int ONLY_CUSTOMQUERY = 32;
    public final static int All = 63;

    public StdOutServant() {
        this.showLevel = All;
    }

    public StdOutServant(int showLevel) {
        this.showLevel = showLevel;
    }

    protected void handle(AfterTask atask) {
        println(atask.getStart(), atask.getEnd(), atask.getQueryable());
    }

    private void println(long start, long end, IQueryable query) {
        System.out.print(query.toString());
        System.out.println("\nactual time(ms) : " + (end - start) + "\n");
    }

    protected boolean isDealWith(AfterTask atask) {
//        return (
//            ( (showLevel / 16) % 2 == 1 && query instanceof UserCommandBatch) ||
//            ( (showLevel / 8) % 2 == 1 && query instanceof UserProcedures) ||
//            ( (showLevel / 4) % 2 == 1 && query instanceof UserProcedureBatch) ||
//            ( (showLevel / 2) % 2 == 1 && query instanceof UserCommand) ||
//            ( (showLevel / 1) % 2 == 1 && query instanceof UserProcedure)
//            );
//
    	IQueryable query = atask.getQueryable() ;
        return  (this.showLevel == StdOutServant.All) || (
          ( (showLevel / 32) % 2 == 1 && query.getQueryType() == QueryType.CUSTOM_QUERY) ||
          ( (showLevel / 16) % 2 == 1 && query.getQueryType() == QueryType.USER_COMMAND_BATCH) ||
          ( (showLevel / 8) % 2 == 1 && query.getQueryType() ==  QueryType.USER_PROCEDURES) ||
          ( (showLevel / 4) % 2 == 1 && query.getQueryType() ==  QueryType.USER_PROCEDURE_BATCH) ||
          ( (showLevel / 2) % 2 == 1 && query.getQueryType() == QueryType.USER_COMMAND) ||
          ( (showLevel / 1) % 2 == 1 && query.getQueryType() == QueryType.USER_PROCEDURE)
          )  ;
    }

    public String toString() {
        return "StdOutServant [showLevel=" + showLevel + "]";
    }

	public ExtraServant newCloneInstance() {
		return new StdOutServant(this.showLevel) ;
	}

}
