package com.bleujin.framework.db.servant;

import java.sql.SQLException;

import com.bleujin.framework.db.DBController;
import com.bleujin.framework.db.procedure.IQueryable;
import com.bleujin.framework.db.procedure.IUserProcedure;


public class TraceOfLateProcServant extends ExtraServant
{
    private int limitMilisecond;

	public TraceOfLateProcServant(int limitMilisecond) {
		this.limitMilisecond = limitMilisecond;
	}


    protected void handle(AfterTask atask)
    {
    	IQueryable query = atask.getQueryable() ;
        final String procName = query.getProcSQL() ;
        final String procFullName = query.getProcFullSQL() ;
        final int misecond = Integer.parseInt(String.valueOf(atask.getEnd() - atask.getStart())) ;
        final DBController dc = new DBController(atask.getDBManager()) ;
        new Thread(){
            public void run(){
                try {
                    IUserProcedure upt = dc.createUserProcedure("OnlyAdmin@addLongTimeProcedure(?,?,?)") ;
                    upt.addParam(0, procName) ;
                    upt.addParam(1, procFullName.length() > 1000 ? procFullName.substring(0, 1000) : procFullName) ;
                    upt.addParam(2, misecond) ;
                    upt.execUpdate() ;
                }
                catch(SQLException ex) {
                    ex.printStackTrace();
                }
            }
        }.start();
    }

    protected boolean isDealWith(AfterTask atask) {
        return (atask.getEnd()- atask.getStart() > this.limitMilisecond) ;
    }

    public String toString(){
        return "TraceOfLateProcServant [limitMilisecond=" + limitMilisecond + "]" ;
    }
    
	public ExtraServant newCloneInstance() {
		return new TraceOfLateProcServant(this.limitMilisecond) ;
	}


}
