package com.bleujin.framework.exception;

/**
 * @author Choi sei hwan <a href="mailto:sehan@i-on.net">Choi sei hwan</a>
 * @version 1.0
 * 
 *          <pre>
 *  Exception  óϴ ߻Ŭ
 * 
 * resolve , done, fail  ExceptionHandler Ŭ ӹ޾ Ѵ.
 * 
 */

public abstract class ExceptionHandler {
	protected ExceptionHandler next = null;

	/**
	 * ڵ鷯 óҼ  exception ؼ Ѱ next ڵ鷯 Ѵ.
	 * 
	 * @param nextHandler
	 *            ExceptionHandler
	 */
	final public void setNext(ExceptionHandler nextHandler) {
		this.next = nextHandler;
	}

	/**
	 * Handler  ۽Ű żҵ. resolve żҵ带 ̿ؼ óɿθ Ȯ óϸ done żҵ带 ϰ
	 * óҰϸ next ڵ鷯 ִ Ȯؼ  next ڵ鷯 Ѱְ ٸ fail żҵ带 Ѵ.
	 * 
	 * @param exInfo
	 *            ExceptionInfo
	 */
	final public void resolve(ExceptionInfo exInfo) {
		if (isSupport(exInfo)) {
			done(exInfo);
		} else if (next != null) {
			next.resolve(exInfo);
		} else {
			fail(exInfo);
		}
	}

	/**
	 * ExceptionInfo   óҼ ִ  Ȯϴ ڵ带 Ѵ.
	 * 
	 * @param exInfo
	 *            ExceptionInfo
	 * @return boolean true -  ڵ鷯 óϸ , false - óҰϸ
	 */
	protected abstract boolean isSupport(ExceptionInfo exInfo);

	/**
	 * óҼ ִ Exception ϶ ش ڵ鷯 ó ڵ带 Ѵ.
	 * 
	 * @param exInfo
	 *            ExceptionInfo
	 */
	protected abstract void done(ExceptionInfo exInfo);

	/**
	 * óҼ  Exception ε next ڵ鷯  ó ڵ Ѵ.
	 * 
	 * @param exInfo
	 *            ExceptionInfo
	 */
	protected void fail(ExceptionInfo exInfo) {
		exInfo.recordException();
	}

}
