package com.bleujin.framework.exception;

import java.util.Hashtable;
import java.util.Stack;

/**
 * @author Choi sei hwan <a href="mailto:sehan@i-on.net">Choi sei hwan</a>
 * @version 1.0
 */

public class ExceptionManager {
	private static Hashtable exceptionManagerCache = new Hashtable();

	private String managerName = null;

	private Stack exceptionChain = new Stack();

	/**
	 * ExceptionManager  Ѵ. Manager ̸ parameter  ޴´. Manager 
	 * ExceptionManagerFactory getExceptionManager() ޼ҵ Ѵ.
	 * 
	 * @param managerName
	 *            String
	 */
	private ExceptionManager(String managerName) {
		this.managerName = managerName;
	}

	/**
	 * ExceptionManager  ´.
	 * 
	 * @param managerName
	 *            String  ExceptionManager  ̸
	 * @return ExceptionManager
	 */
	public static ExceptionManager getExceptionManager(String managerName) {
		ExceptionManager manager = (ExceptionManager) (exceptionManagerCache.get(managerName));

		if (manager == null) {
			manager = new ExceptionManager(managerName);
			exceptionManagerCache.put(managerName, manager);
		}

		return manager;
	}

	/**
	 * ExceptionHandler  Ѵ. ϵ  exceptionChain  ȴ.
	 * 
	 * @param handler
	 *            ExceptionHandler
	 */
	public void addHandler(ExceptionHandler handler) {
		Object lastHandler = null;

		if (!exceptionChain.isEmpty()) {
			lastHandler = exceptionChain.pop();
			((ExceptionHandler) lastHandler).setNext(handler);
			exceptionChain.push(lastHandler);
		}

		exceptionChain.push(handler);
	}

	/**
	 * exception óѴ.
	 * 
	 * @param exInfo
	 *            ExceptionInfo
	 */
	public void execHandler(ExceptionInfo exInfo) {
		((ExceptionHandler) exceptionChain.firstElement()).resolve(exInfo);
	}

	/**
	 * ExceptionManager ̸ ´.
	 * 
	 * @return String
	 */
	public String getName() {
		return managerName;
	}

	/**
	 * ϵǾִ ExceptionHandler  ´.
	 * 
	 * @return int
	 */
	public int getChainSize() {
		return exceptionChain.size();
	}

	/**
	 * ϵǾִ ExceptionHandler λѴ.
	 * 
	 */
	public void clearHandler() {
		exceptionChain.clear();
	}

}
