package com.bleujin.framework.tools;

public class SysProperties {

	public static final String FILE_ENCODING = getStringSetting("file.encoding", "Cp1252");
	public static final String FILE_SEPARATOR = getStringSetting("file.separator", "/");
	public static final String LINE_SEPARATOR = getStringSetting("line.separator", "\n");	

    public static String getStringSetting(String name, String defaultValue) {
        String s = getProperty(name);
        return s == null ? defaultValue : s;
    }
    
    private static String getProperty(String name) {
        try {
            return System.getProperty(name);
        } catch (SecurityException e) {
            // applets may not do that - ignore
            return null;
        }
    }    
}
