package com.bleujin.framework.valid.validator;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

import com.bleujin.framework.util.StringUtil;
import com.bleujin.framework.valid.IValueObject;

public class RegularExpression extends BaseValidation{


	private String expression ;
	public RegularExpression(IValueObject value, String name, String expression) {
		super(value, name);
		this.expression = expression ;
	}

	public boolean isValid() {
		if (StringUtil.isEmpty(expression)) return false ;

		Object value = invokeGetter() ;
		String stringValue = ((value == null) ? "" : value.toString()) ;
		
		Pattern p = Pattern.compile(expression);
		Matcher m = p.matcher(stringValue);
		return m.matches();
	}

}
